be-wise/Controllers/AuthController.cs
using System.Security.Claims;
using be_wise.Models.Auth;
using be_wise.Repositories;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Mvc;

namespace be_wise.Controllers
{
    public class AuthController : Controller
    {

        private readonly AuthRepository _authRepository;

        public AuthController(AuthRepository authRepository)
        {
            this._authRepository = authRepository;
        }
        
        // GET
        public IActionResult Login()
        {
            if (HttpContext.User.Identity.IsAuthenticated)
            {
                return RedirectToAction("Index", "Home");
            }
            
            return View("Login");
        }

        [HttpPost]
        public IActionResult Login(LoginViewModel credentials)
        {
            
            // TODO add some validation

            var claims = this._authRepository.Login(credentials);
            var login = HttpContext.SignInAsync(CookieAuthenticationDefaults.AuthenticationScheme, claims);
            
            return RedirectToAction("Index", "Home"); 
        }
        
        
        // GET
        public IActionResult Register()
        {
            if (HttpContext.User.Identity.IsAuthenticated)
            {
                return RedirectToAction("Index", "Home");
            }
            
            return View("Register");
        }

        [HttpPost]
        public IActionResult Register(RegisterViewModel registerData)
        {
            this._authRepository.Register(registerData);

            return RedirectToAction("Login");
        }

        public IActionResult Logout()
        {
            if (!HttpContext.User.Identity.IsAuthenticated)
            {
                return RedirectToAction("Index", "Home");
            }
            
            var login = HttpContext.SignOutAsync(CookieAuthenticationDefaults.AuthenticationScheme);  
            return RedirectToAction("Login");  
        }
    }
}

be-wise/Controllers/CategoriesController.cs
using System.Linq;
using be_wise.Models.Home.Dto;
using be_wise.Repositories;
using Microsoft.AspNetCore.Mvc;

namespace be_wise.Controllers
{
    public class CategoriesController : Controller
    {
        private readonly CategoriesRepository _categoriesRepository;

        public CategoriesController(CategoriesRepository categoriesRepository)
        {
            this._categoriesRepository = categoriesRepository;
        }
        
        public IActionResult Index(int categoryId)
        {
            var categories = this._categoriesRepository.GetCategories().Select(x => new CategoryDto
            {
                Id = x.Id,
                Title = x.Title,
                ImageUrl = x.Cover
            }).ToList();
            
            return View("Index", categories);
        }
    }
}

be-wise/Controllers/DashboardController.cs
using System;
using System.Linq;
using be_wise.Models.Dashboard;
using be_wise.Models.Dashboard.Dto;
using be_wise.Repositories;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace be_wise.Controllers
{
    [Authorize]
    public class DashboardController : Controller
    {
        private readonly UsersRepository _usersRepository;
        private readonly PostsRepository _postsRepository;
        
        public DashboardController(UsersRepository usersRepository, PostsRepository postsRepository)
        {
            this._usersRepository = usersRepository;
            this._postsRepository = postsRepository;
        }
        
        // GET
        public IActionResult Index()
        {
            var viewModel = new DashboardViewModel
            {
                UsersCount = this._usersRepository.UsersCount(),
                AllPostsCount = this._postsRepository.PostsCount(),
                PendingPostsCount = this._postsRepository.PendingPostsCount(),
                PostsInMonthCount = this._postsRepository.PostsInMonthCount(DateTime.Now),
                PendingPosts = this._postsRepository.GetPendingPosts().Select(x => new PostDto
                {
                    Id = x.Id,
                    Title = x.Title,
                    ImageUrl = x.ImagePath,
                    InsertedAt = x.InsertedAt,
                    IsPending = x.IsPending
                })
            };
            
            return View("Index", viewModel);
        }

        public IActionResult Accept(int id)
        {
            this._postsRepository.AcceptPost(id);
            
            return RedirectToAction("Index");
        }
        
        public IActionResult Reject(int id)
        {
            this._postsRepository.RejectPost(id);
            
            return RedirectToAction("Index");
        }
    }
}

be-wise/Controllers/PostsController.cs
using System.Linq;
using be_wise.Models.Home.Dto;
using be_wise.Repositories;
using Microsoft.AspNetCore.Mvc;

namespace be_wise.Controllers
{
    public class PostsController : Controller
    {
        private readonly PostsRepository _postsRepository;
        
        public PostsController(PostsRepository postsRepository)
        {
            this._postsRepository = postsRepository;
        }

        public IActionResult CategorisedPosts(int id, int page = 1)
        {
            var postsCollection = new PostCollectionDto();

            var totalItems = this._postsRepository.GetPostsForCategoryCount(id);
            var pagesCount = (totalItems / 20);
            
            postsCollection.CanPrevious = page > 1;
            postsCollection.CanNext = page < pagesCount;
            postsCollection.PagesCount = pagesCount > 0 ? pagesCount : 1;
            postsCollection.Page = page;
            postsCollection.NextPage = page + 1;
            postsCollection.PreviousPage = page - 1;
            
            postsCollection.Posts = this._postsRepository.GetPostsForCategory(id, 20, page)
                .Select(x => new PostDto
            {
                Id = x.Id,
                Title = x.Title,
                ImageUrl = x.ImagePath
            }).ToList();
            
            return View("CategorisedPosts", postsCollection);
        }

        public IActionResult NewestPosts(int page = 1)
        {
            var postsCollection = new PostCollectionDto();

            var totalItems = this._postsRepository.AcceptedPostsCount();
            var pagesCount = (totalItems / 20);
            
            postsCollection.CanPrevious = page > 1;
            postsCollection.CanNext = page < pagesCount;
            postsCollection.PagesCount = pagesCount > 0 ? pagesCount : 1;
            postsCollection.Page = page;
            postsCollection.NextPage = page + 1;
            postsCollection.PreviousPage = page - 1;
            
            postsCollection.Posts = this._postsRepository.GetNewestPosts(20).Select(x => new PostDto
            {
                Id = x.Id,
                Title = x.Title,
                ImageUrl = x.ImagePath
            }).ToList();
            
            return View("NewestPosts", postsCollection);
        }

        public IActionResult ShowPost(int id)
        {
            var post = this._postsRepository.GetPost(id);
            var postDto = new PostDto
            {
                Id = post.Id,
                Title = post.Title,
                ImageUrl = post.ImagePath
            };
            
            return View("ShowPost", postDto);
        }
    }
}

be-wise/Views/Shared/_DashboardLayout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - be wise</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css"/>
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"/>
    </environment>
    <link href="~/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">
    <link rel="stylesheet" href="~/css/sb-admin-2.min.css"/>
    <link rel="stylesheet" href="~/css/dashboard.css"/>
</head>
<body id="page-top">
<!-- Page Wrapper -->
<div id="wrapper">

<!-- Sidebar -->
<ul class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion" id="accordionSidebar">

    <!-- Sidebar - Brand -->
    <a class="sidebar-brand d-flex align-items-center justify-content-center" asp-action="Index" asp-controller="Home">
        <div class="sidebar-brand-icon rotate-n-15">
            <i class="fas fa-book-open"></i>
        </div>
        <div class="sidebar-brand-text mx-3">be wise</div>
    </a>

    <!-- Divider -->
    <hr class="sidebar-divider my-0">

    <!-- Nav Item - Dashboard -->
    <li class="nav-item active">
        <a class="nav-link" asp-action="Index" asp-controller="Dashboard">
            <i class="fas fa-fw fa-home"></i>
            <span>Dashboard</span>
        </a>
    </li>

    <!-- Divider -->
    <hr class="sidebar-divider">

    <!-- Heading -->
    <div class="sidebar-heading">
        Posty
    </div>

    <li class="nav-item">
        <a class="nav-link collapsed" asp-controller="CategoriesManagement" asp-action="Index">
            <i class="fas fa-fw fa-bookmark"></i>
            <span>Kategorie</span>
        </a>
    </li>

    <li class="nav-item">
        <a class="nav-link collapsed" asp-controller="PostsManagement" asp-action="Index">
            <i class="fas fa-fw fa-quote-left"></i>
            <span>Posty</span>
        </a>
    </li>

    <!-- Divider -->
    <hr class="sidebar-divider">

    <!-- Heading -->
    <div class="sidebar-heading">
        Użytkownicy
    </div>

    <li class="nav-item">
        <a class="nav-link collapsed" asp-controller="UsersManagement" asp-action="Index">
            <i class="fas fa-fw fa-users"></i>
            <span>Zarejestrowani</span>
        </a>
    </li>

    <li class="nav-item">
        <a class="nav-link" asp-controller="AdminsManagement" asp-action="Index">
            <i class="fas fa-fw fa-users"></i>
            <span>Moderatorzy</span>
        </a>
    </li>

    <!-- Divider -->
    <hr class="sidebar-divider d-none d-md-block">

</ul>
<!-- End of Sidebar -->

<!-- Content Wrapper -->
<div id="content-wrapper" class="d-flex flex-column">

<!-- Main Content -->
<div id="content">

    <!-- Topbar -->
    <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">

        <!-- Page Heading -->
        <div class="d-sm-flex align-items-center justify-content-between">
            <h1 class="h2 text-gray-800" style="margin: 0;">@ViewData["Title"]</h1>
        </div>

        <!-- Topbar Navbar -->
        <ul class="navbar-nav ml-auto">

            <!-- Nav Item - Search Dropdown (Visible Only XS) -->
            <li class="nav-item dropdown no-arrow d-sm-none">
                <a class="nav-link dropdown-toggle" href="#" id="searchDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-search fa-fw"></i>
                </a>
                <!-- Dropdown - Messages -->
                <div class="dropdown-menu dropdown-menu-right p-3 shadow animated--grow-in" aria-labelledby="searchDropdown">
                    <form class="form-inline mr-auto w-100 navbar-search">
                        <div class="input-group">
                            <input type="text" class="form-control bg-light border-0 small" placeholder="Search for..." aria-label="Search" aria-describedby="basic-addon2">
                            <div class="input-group-append">
                                <button class="btn btn-primary" type="button">
                                    <i class="fas fa-search fa-sm"></i>
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </li>

            <div class="topbar-divider d-none d-sm-block"></div>

            <!-- Nav Item - User Information -->
            <li class="nav-item dropdown no-arrow">
                <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span class="mr-2 d-none d-lg-inline text-gray-600 small">
                        Cześć, @User.Identity.Name
                    </span>
                </a>
                <!-- Dropdown - User Information -->
                <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in" aria-labelledby="userDropdown">
                    <a class="dropdown-item" asp-controller="Account" asp-action="Index">
                        <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                        Profil
                    </a>
                    <div class="dropdown-divider"></div>
                    <a class="dropdown-item" asp-controller="Auth" asp-action="Logout">
                        <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                        Wyloguj
                    </a>
                </div>
            </li>

        </ul>

    </nav>
    <!-- End of Topbar -->

    <!-- Begin Page Content -->
    <div class="container-fluid">
        @RenderBody()
    </div>
    <!-- /.container-fluid -->

</div>
<!-- End of Main Content -->

<!-- Footer -->
<footer class="sticky-footer bg-white">
    <div class="container my-auto">
        <div class="copyright text-center my-auto">
            <span>Prawa autorskie &copy; be wise 2019</span>
        </div>
    </div>
</footer>
<!-- End of Footer -->

</div>
<!-- End of Content Wrapper -->

</div>
<!-- End of Page Wrapper -->

<!-- Scroll to Top Button-->
<a class="scroll-to-top rounded" href="#page-top">
    <i class="fas fa-angle-up"></i>
</a>

<environment include="Development">
    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
</environment>
<environment exclude="Development">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
            asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
            asp-fallback-test="window.jQuery"
            crossorigin="anonymous"
            integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
            asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
            asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
            crossorigin="anonymous"
            integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
</environment>
<script src="~/js/site.js" asp-append-version="true"></script>

@RenderSection("Scripts", required: false)
</body>
</html>

be-wise/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"]</title>
    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css"/>
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"/>
    </environment>
    <link rel="stylesheet" href="~/css/site.css"/>
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3 fixed-top">
        <div class="container">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">be wise</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row">
                <ul class="navbar-nav flex-grow-1">
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Strona główna</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Categories" asp-action="Index">Kategorie</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Posts" asp-action="NewestPosts" asp-route-page="1">Najnowsze</a>
                    </li>
                </ul>

                @if (User.Identity.IsAuthenticated)
                {
                    <ul class="nav nav-tabs">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Hello, @User.Identity.Name</a>
                            <div class="dropdown-menu">
                                <a class="dropdown-item" asp-controller="Account" asp-action="Index">Profil</a>
                                @if (User.IsInRole("admin"))
                                {
                                    <a class="dropdown-item" asp-action="Index" asp-controller="Dashboard">Administracja</a>
                                }
                                <div class="dropdown-divider"></div>
                                <a class="dropdown-item" onclick="document.getElementById('logout_form').submit();" style="cursor: pointer;">Wyloguj</a>
                            </div>
                        </li>
                    </ul>

                    <form asp-controller="Auth" asp-action="Logout" method="post" id="logout_form" style="display: none;"></form>
                }
                else
                {
                    <ul class="navbar-nav flex-grow-0">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Auth" asp-action="Login">Logowanie</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Auth" asp-action="Register">Rejestracja</a>
                        </li>
                    </ul>
                }
            </div>
        </div>
    </nav>
    @RenderSection("JumbotronSection", false)
</header>
<div class="container">
    <partial name="_CookieConsentPartial"/>
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted fixed-bottom">
    <div class="container">
        &copy; 2019 - be wise - <a asp-area="" asp-controller="Home" asp-action="Privacy">Polityka prywatności</a>
    </div>
</footer>

<environment include="Development">
    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
</environment>
<environment exclude="Development">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
            asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
            asp-fallback-test="window.jQuery"
            crossorigin="anonymous"
            integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
            asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
            asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
            crossorigin="anonymous"
            integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
</environment>
<script src="https://cdnjs.cloudflare.com/ajax/libs/animejs/2.0.2/anime.min.js"></script>
<script src="~/js/site.js" asp-append-version="true"></script>
@RenderSection("Scripts", required: false)
</body>
</html>